Index: trunk/XTIDE_Universal_BIOS/Src/StringsCompressed.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS/Src/StringsCompressed.asm	(revision 241)
+++ trunk/XTIDE_Universal_BIOS/Src/StringsCompressed.asm	(revision 252)
@@ -2,5 +2,5 @@
 ;;;
 ;;; This file is generated by StringsCompress.pl from source in Strings.asm
-;;; DO NOT EDIT DIRECTLY - See the maekfile for how to rebuild this file.
+;;; DO NOT EDIT DIRECTLY - See the makefile for how to rebuild this file.
 ;;; This file only needs to be rebuilt if Strings.asm is changed.
 ;;;
@@ -18,9 +18,9 @@
 
 ; The following strings are used by DetectPrint_StartDetectWithMasterOrSlaveStringInAXandIdeVarsInCSBP
-; To support an optimization in that code, these strings must start on the same 256 byte page, 
+; To support an optimization in that code, these strings must start on the same 256 byte page,
 ; which is checked at assembly time below.
 ;
-g_szDetectStart:		
-g_szDetectMaster:		; db	"Master",NULL 
+g_szDetectStart:
+g_szDetectMaster:		; db	"Master",NULL
                  		; db	 4dh,  61h,  73h,  74h,  65h,  72h,  00h    ; uncompressed
                  		  db	 53h,  67h,  79h,  7ah,  6bh, 0b8h          ; compressed
@@ -38,5 +38,5 @@
                			  db	 19h                ; compressed
 
-g_szDetectCOM:			; db  "COM%c%s",NULL            
+g_szDetectCOM:			; db  "COM%c%s",NULL
               			; db   43h,  4fh,  4dh,  25h,  63h,  25h,  73h,  00h    ; uncompressed
               			  db   49h,  55h,  53h,  35h,  1eh                      ; compressed
@@ -56,5 +56,5 @@
 
 
-%ifndef CHECK_FOR_UNUSED_ENTRYPOINTS				
+%ifndef CHECK_FOR_UNUSED_ENTRYPOINTS
 %if ((g_szDetectEnd-$$) & 0xff00) <> ((g_szDetectStart-$$) & 0xff00)
 %error "g_szDetect* strings must start on the same 256 byte page, required by DetectPrint_StartDetectWithMasterOrSlaveStringInAXandIdeVarsInCSBP.  Please move this block up or down within strings.asm"
@@ -63,10 +63,10 @@
 
 ; Boot Menu menuitem strings
-; 
+;
 ; The following strings are used by BootMenuPrint_* routines.
-; To support optimizations in that code, these strings must start on the same 256 byte page, 
+; To support optimizations in that code, these strings must start on the same 256 byte page,
 ; which is checked at assembly time below.
-;		
-g_szBootMenuPrintStart:	
+;
+g_szBootMenuPrintStart:
 g_szDriveNum:			; db	"%x %s",NULL
              			; db	 25h,  78h,  20h,  25h,  73h,  00h    ; uncompressed
@@ -81,5 +81,5 @@
               			  db	 4ch,  72h,  75h,  76h,  76h, 0ffh,  4ah,  78h,  6fh,  7ch, 0ebh,  15h                            ; compressed
 
-g_szBootMenuPrintEnd:	
+g_szBootMenuPrintEnd:
 g_szForeignHD:			; db	"Foreign Hard Disk",NULL
               			; db	 46h,  6fh,  72h,  65h,  69h,  67h,  6eh,  20h,  48h,  61h,  72h,  64h,  20h,  44h,  69h,  73h,  6bh,  00h    ; uncompressed
@@ -87,5 +87,5 @@
 
 
-%ifndef CHECK_FOR_UNUSED_ENTRYPOINTS				
+%ifndef CHECK_FOR_UNUSED_ENTRYPOINTS
 %if ((g_szBootMenuPrintStart-$$) & 0xff00) <> ((g_szBootMenuPrintEnd-$$) & 0xff00)
 %error "g_szBootMenuPrint* strings must start on the same 256 byte page, required by the BootMenuPrint_* routines.  Please move this block up or down within strings.asm"
@@ -140,11 +140,11 @@
              			  db	 49h,  67h,  76h,  67h,  69h,  6fh,  7ah, 0ffh, 0c0h,  1eh                            ; compressed
 
-g_szCapacityNum:		; db	"%5-u.%u %ciB",NULL		
+g_szCapacityNum:		; db	"%5-u.%u %ciB",NULL
                 		; db	 25h,  35h,  2dh,  75h,  2eh,  25h,  75h,  20h,  25h,  63h,  69h,  42h,  00h    ; uncompressed
                 		  db	 38h,  29h,  37h,  20h,  35h,  6fh,  88h                                        ; compressed
 
-g_szSizeDual:			; db	"%s /%s",LF,CR
-             			; db	 25h,  73h,  20h,  2fh,  25h,  73h,  0ah,  0dh    ; uncompressed
-             			  db	 3eh,  20h,  2ah,  3eh,  3bh                      ; compressed
+g_szInformation:		; db	"%s",LF,CR
+                		; db	 25h,  73h,  0ah,  0dh    ; uncompressed
+                		  db	 3eh,  3bh                ; compressed
 
 	; db	"Addr.",SINGLE_VERTICAL,"Block",SINGLE_VERTICAL,"Bus",SINGLE_VERTICAL,  "IRQ",SINGLE_VERTICAL,"Reset",LF,CR
@@ -158,10 +158,10 @@
 
 ; Boot Menu Floppy Disk strings
-; 
+;
 ; The following strings are used by BootMenuPrint_RefreshInformation
-; To support optimizations in that code, these strings must start on the same 256 byte page, 
+; To support optimizations in that code, these strings must start on the same 256 byte page,
 ; which is checked at assembly time below.
-;				
-g_szFddStart:	
+;
+g_szFddStart:
 g_szFddUnknown:	; db	"Unknown",NULL
                	; db	 55h,  6eh,  6bh,  6eh,  6fh,  77h,  6eh,  00h    ; uncompressed
@@ -180,5 +180,5 @@
                  		  db   2dh,  02h          ; compressed
 
-g_szFddEnd:		
+g_szFddEnd:
 g_szFddFiveQuarter:		; db  "5",ONE_QUARTER,NULL
                    		; db   35h, 0ach,  00h    ; uncompressed
@@ -186,11 +186,11 @@
 
 
-%ifndef CHECK_FOR_UNUSED_ENTRYPOINTS				
+%ifndef CHECK_FOR_UNUSED_ENTRYPOINTS
 %if ((g_szFddStart-$$) & 0xff00) <> ((g_szFddEnd-$$) & 0xff00)
 %error "g_szFdd* strings must start on the same 256 byte page, required by the BootMenuPrint_RefreshInformation routines for floppy drives.  Please move this block up or down within strings.asm"
 %endif
-%endif						
-
-g_szAddressingModes:					
+%endif
+
+g_szAddressingModes:
 g_szLCHS:		; db	"L-CHS",NULL
          		; db	 4ch,  2dh,  43h,  48h,  53h,  00h    ; uncompressed
@@ -213,5 +213,5 @@
 ; Ensure that addressing modes are correctly spaced in memory
 ;
-%ifndef CHECK_FOR_UNUSED_ENTRYPOINTS		
+%ifndef CHECK_FOR_UNUSED_ENTRYPOINTS
 %if g_szLCHS <> g_szAddressingModes
 %error "g_szAddressingModes Displacement Incorrect 1"
@@ -220,13 +220,13 @@
 %error "g_szAddressingModes Displacement Incorrect 2"
 %endif
-%if g_szLBA28 <> g_szPCHS + g_szAddressingModes_Displacement		
+%if g_szLBA28 <> g_szPCHS + g_szAddressingModes_Displacement
 %error "g_szAddressingModes Displacement Incorrect 3"
 %endif
-%if g_szLBA48 <> g_szLBA28 + g_szAddressingModes_Displacement		
+%if g_szLBA48 <> g_szLBA28 + g_szAddressingModes_Displacement
 %error "g_szAddressingModes Displacement Incorrect 4"
 %endif
-%endif		
-
-g_szBusTypeValues:		
+%endif
+
+g_szBusTypeValues:
 g_szBusTypeValues_8Dual:		; db		"D8 ",NULL
                         		; db		 44h,  38h,  20h,  00h    ; uncompressed
@@ -257,22 +257,22 @@
 ; Ensure that bus type strings are correctly spaced in memory
 ;
-%ifndef CHECK_FOR_UNUSED_ENTRYPOINTS				
+%ifndef CHECK_FOR_UNUSED_ENTRYPOINTS
 %if g_szBusTypeValues_8Dual <> g_szBusTypeValues
 %error "g_szBusTypeValues Displacement Incorrect 1"
 %endif
 %if g_szBusTypeValues_8Reversed <> g_szBusTypeValues + g_szBusTypeValues_Displacement
-%error "g_szBusTypeValues Displacement Incorrect 2"		
+%error "g_szBusTypeValues Displacement Incorrect 2"
 %endif
 %if g_szBusTypeValues_8Single <> g_szBusTypeValues_8Reversed + g_szBusTypeValues_Displacement
-%error "g_szBusTypeValues Displacement Incorrect 3"				
-%endif
-%if g_szBusTypeValues_16 <> g_szBusTypeValues_8Single + g_szBusTypeValues_Displacement		
-%error "g_szBusTypeValues Displacement Incorrect 4"				
+%error "g_szBusTypeValues Displacement Incorrect 3"
+%endif
+%if g_szBusTypeValues_16 <> g_szBusTypeValues_8Single + g_szBusTypeValues_Displacement
+%error "g_szBusTypeValues Displacement Incorrect 4"
 %endif
 %if g_szBusTypeValues_32 <> g_szBusTypeValues_16 + g_szBusTypeValues_Displacement
-%error "g_szBusTypeValues Displacement Incorrect 5"				
+%error "g_szBusTypeValues Displacement Incorrect 5"
 %endif
 %if g_szBusTypeValues_Serial <> g_szBusTypeValues_32 + g_szBusTypeValues_Displacement
-%error "g_szBusTypeValues Displacement Incorrect 6"				
+%error "g_szBusTypeValues Displacement Incorrect 6"
 %endif
 %endif
@@ -290,5 +290,5 @@
 
 ;------------------------------------------------------------------------------------------
-; 
+;
 ; Tables for StringsCompress.pl
 ;
@@ -304,5 +304,5 @@
 ;$translate{ord('.')} = 9;    [StringsCompress Processed]
 ;$translate{ord('/')} = 10;    [StringsCompress Processed]
-;$translate{ord('1')} = 11;        [StringsCompress Processed]
+;$translate{ord('1')} = 11;    [StringsCompress Processed]
 ;$translate{ord('2')} = 12;    [StringsCompress Processed]
 ;$translate{ord('3')} = 13;    [StringsCompress Processed]
@@ -334,5 +334,5 @@
 ;
 ; Starting point for the "normal" range, typically around 0x40 to cover upper and lower case
-; letters.  If lower case 'z' is not used, 0x3a can be a good choice as it adds ':' to the 
+; letters.  If lower case 'z' is not used, 0x3a can be a good choice as it adds ':' to the
 ; front end.
 ;
@@ -342,6 +342,4 @@
 ;
 ;------------------------------------------------------------------------------------------
-
-
 
 ;;; end of input stream
@@ -423,5 +421,5 @@
 ;; translated usage stats
 ;; 33:1
-;; 32:31
+;; 32:30
 ;; 181:1
 ;; 53:2
@@ -433,5 +431,5 @@
 ;; 50:2
 ;; 51:3
-;; 47:3
+;; 47:2
 ;; 52:1
 ;; 172:2
@@ -450,5 +448,5 @@
 ;; 5-u:2
 ;; x:7
-;; s:13
+;; s:12
 ;; 5-x:1
 ;; nl:6